;; 
;; j- version of dabbrev-expand
;; Thu Mar 28 01:00:47 1996
;; Tue Apr 11 14:43:07 2000
;;

(provide 'j-dabbrev)

;; Tue Mar 28 14:59:00 2000
;; The modify-syntax-entry() technique based on teachings from:
;;
;; Path: miles.smoke.or.jp!nifty!SGU01663
;; From: SGU01663@nifty.ne.jp ($B>>ED!!LP<y(B)
;; Newsgroups: nifty.funix.linux
;; Subject: Re: j-dabbrev-expand
;; Date: 28 Mar 2000 13:57:00 +0900
;; Message-ID: <11318@nifty.funix.mes19>
;; Distribution: nifty
;; References: <11316@nifty.funix.mes19>
;; X-Nifty-Room: Linux $B3hMQ!&1~MQ!&3+H/(B
;; Lines: 40
;; Xref: miles.smoke.or.jp nifty.funix.linux:9291
;;

;; This defadvice() and defun() improves the behaviour of
;; dabbrev-expand() in ~/elisp/1928dabbrev.el, loaded into
;; emacs-20.xx. NOP on E19.xx.

(defadvice dabbrev-expand (before dabbrev-ad activate)
  (20-modify-syntax-entry-for-dabbrev))

(defun 20-modify-syntax-entry-for-dabbrev ()
  (cond ((string< "20" emacs-version)
	 ;; (message "the advice called") ; debugger
	 (modify-syntax-entry ?$B!"(B ".")
	 (modify-syntax-entry ?$B!#(B "."))))

;; (global-set-key "\e " 'j-dabbrev-expand)
;; (global-set-key "\e " 'dabbrev-expand)
 
;; dabbrev-expand: an interactive compiled Lisp function.
;; (dabbrev-expand ARG)
;; 
;; Expand previous word "dynamically".
;; Expands to the most recent, preceding word for which this is a prefix.
;; If no suitable preceding word is found, words following point are considered.
;; 
;; If `case-fold-search' and `case-replace' are non-nil (usually true)
;; then the substituted word may be case-adjusted to match the abbreviation
;; that you had typed.  This takes place if the substituted word, as found,
;; is all lower case, or if it is at the beginning of a sentence and only
;; its first letter was upper case.
;; 
;; A positive prefix arg N says to take the Nth backward DISTINCT
;; possibility.  A negative argument says search forward.  The variable
;; `dabbrev-backward-only' may be used to limit the direction of search to
;; backward if set non-nil.
;; 
;; If the cursor has not moved from the end of the previous expansion and
;; no argument is given, replace the previously-made expansion
;; with the next possible expansion not yet tried.

(defun j-dabbrev-expand (arg)
  (interactive "*P")
  (dabbrev-expand arg)
  (setq this-command 'insert))

;; Inserts dabbrev in sequence.
(defun e-dabbrev-expand (arg)
  (interactive "*P")
  (dabbrev-expand 1)
  (insert " ")
  (setq this-command 'insert))
