;;; skk-lib.el -- Collector's Items Derived from `Classic' SKK 

(provide 'lkk-skklib)

;;
;; I borrowed these codes from the Good Old skk5.30 to survive with lkk.
;; I can't afford to have much time to write these from scratch, and have
;; no confidence that I could write neater version.
;; 
;; I did not changed `j-' prefix as I believe it does not conflict with
;; current skk.
;;
;; With my biggest homage to M.S., the creator of SKK,
;; s.n.
;; Tue Mar  7 18:09:06 2000
;;


;; This file should share this CREDITS / COPYRIGHT / COPYING policy of SKK 5.30:

;; ========================================================================
;; SKK (Simple Kana to Kanji conversion program)
;; version 5.30 of May 9, 1992
;; Copyright (C) 1988, 1992 Masahiko Sato (masahiko@sato.riec.tohoku.ac.jp)

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either versions 2, or (at your option)
;; any later version.

;; This program is distributed in the hope that it will be useful
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with SKK, see the file COPYING.  If not, write to the Free
;; Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;; ========================================================================

;;
;; List of query-replace's I've done.
;;
;; (query-replace-regexp "skk-date-ad" "j-date-ad")
;; (query-replace-regexp "skk-number-style" "j-number-style")
;;

;;
;; j-today command
;;
;; Good. No pain at all. Perhaps I type `j-today' much faster.
;; (lkk-bogo-perf '(j-today) 4)
;;  =>(0 . 8660)
;; 
;; (lkk-bogo-perf '(insert (skk-today)) 4)
;;  => (0 . 9869)
;; (lkk-bogo-perf '(skk-today) 4) ; skk-10.49
;;  => (0 . 712)
;;

(defconst j-date-ad nil
  "*If non-nil, j-date is in A.D.  If nil, it is in Nengo (Heisei).")
(defconst j-number-style 1
  "*If nil or 0, numbers in j-date are in Hankaku. If t or 1, in Zenkaku.
Otherwise Kanji.")

(defun j-today ()
  "Insert current date at point in Kanji."
  (interactive)
  (insert (j-date)))

;; modified by Koichi Mori, 1991.1.17

(defun j-date ()
  (let* ((str (current-time-string))
	 (y (- (string-to-int (substring str 20 24)) 1988))
	 (year (if j-date-ad
		   (j-num (substring str 20 24))
		 (if (= y 1) "$B85(B" (j-num (int-to-string y)))))
	 (mon (substring str 4 7))
	 (month
	  (j-num
	   (cdr (assoc mon
		       '(("Jan" . "1") ("Feb" . "2") ("Mar" . "3")
			 ("Apr" . "4") ("May" . "5") ("Jun" . "6")
			 ("Jul" . "7") ("Aug" . "8") ("Sep" . "9")
			 ("Oct" . "10") ("Nov" . "11") ("Dec" . "12"))))))
	 (day (j-num (substring str 8 10)))
	 (dw (substring str 0 3))
	 (day-of-week
	  (cdr (assoc dw
		      '(("Sun" . "$BF|(B") ("Mon" . "$B7n(B") ("Tue" . "$B2P(B")
			("Wed" . "$B?e(B") ("Thu" . "$BLZ(B") ("Fri" . "$B6b(B")
			("Sat" . "$BEZ(B")))))
	 )
    (concat (if j-date-ad "" "$BJ?@.(B") year "$BG/(B"
	    month "$B7n(B" day "$BF|(B" "\(" day-of-week "\)")))

;; modified by Masakazu Takahashi, 1991.3.27
;; modified by Koichi Mori, 1991.1.17

(defun j-num (str)
  "convert a number string to other style according to j-number-style"
  (mapconcat (function j-num1) str ""))

(defun j-num1 (c)
  "convert a number character to other style according to j-number-style"
  (cond ((or (null j-number-style) (eq j-number-style 0))
	 (cdr (assq c
		    '((?0 . "0") (?1 . "1") (?2 . "2") (?3 . "3")
		      (?4 . "4") (?5 . "5") (?6 . "6") (?7 . "7")
		      (?8 . "8") (?9 . "9")(?  . "")))))
	((or (eq j-number-style t) (eq j-number-style 1))
	 (cdr (assq c
		    '((?0 . "$B#0(B") (?1 . "$B#1(B") (?2 . "$B#2(B") (?3 . "$B#3(B")
		      (?4 . "$B#4(B") (?5 . "$B#5(B") (?6 . "$B#6(B") (?7 . "$B#7(B")
		      (?8 . "$B#8(B") (?9 . "$B#9(B")(?  . "")))))
	(t
	 (cdr (assq c
		    '((?0 . "$B!;(B") (?1 . "$B0l(B") (?2 . "$BFs(B") (?3 . "$B;0(B")
		      (?4 . "$B;M(B") (?5 . "$B8^(B") (?6 . "$BO;(B") (?7 . "$B<7(B")
		      (?8 . "$BH,(B") (?9 . "$B6e(B") (?  . "")))))))
