;;; make-init.el --- should be preloaded in batch mode.
;;; s.n. Thu Feb 24 05:04:30 2000

;;(setq debug-on-error t)

(setq load-path (cons "." load-path))

;; Environment and coding system setup. Mostly for `make lkkdict'
(let ((ver (string-to-int emacs-version)))
  (cond ((< 19 ver)
	 (set-language-environment "Japanese")
	 (setq default-buffer-file-coding-system 'euc-japan
	       ;; coding-system-for-read 'euc-japan
	       default-process-coding-system  (cons 'euc-japan 'euc-japan))
	 ;; Perhaps user uses kterm while `make lkkdict', and it can display jis/euc, but
	 ;; My jfbterm can't display the stderr stream while `make lkkdict' even with this. Why ?
	 ;; I don't know what happens on KON...
	 (or window-system
	     (set-terminal-coding-system 'euc-japan))
	 )
	((= 19 ver)
	 (set-default-file-coding-system '*euc-japan*unix)
	 (setq default-process-coding-system
	       (cons '*euc-japan*unix '*euc-japan*unix)))
	(t (error "you need emacs version 19 or later. Sorry."))))


;; Dirty trick for lkk-skk-dichead.el
;;(progn
;;  (setq skk-version nil)
;;  (provide 'skk))

;; Support gzip'ed ~/.skk-jisyo while `make lkkdict'.
;; lkk-insert-file-contents() understands .gz suffix, and the
;; existence of this gizmo.  This should be over-kill because skk
;; doesn't seem to support gzip'ed file, so commented out here:
;; (require 'jka-compr)

;; While `make', this loads lkk.el on bootup, then byte-compile is done.
(require 'lkk)
